/************************************************************************
 *									*
 *		r^f@botvO				*
 *									*
 *				: `h\pc^ovZ		*
 *		t@C	: dp_ai.c				*
 *									*
 ************************************************************************/
#include "sg_cpu.h"

/*=======================================================================
 |
 |		`hsb`@c^ovZ
 |
 |	void	dp_ai_pitch()
 |
 =======================================================================*/
void	dp_ai_pitch()
{
	short	tmp;

	/* kxPOXǎvZ */
	dp_ai.LY109B = (ushort)(2314L - fltdata.IPTCHA * 289L / 128L) << 1;

	/* oxPOX`̌vZ */
	tmp = (short)(fltdata.IPTCHA * 289L / 128L + 72L);
	if (tmp < -606)		/* l␳ */
		tmp = -606;
	else if (tmp > 678)	/* l␳ */
		tmp = 678;
	dp_ai.PY109A = tmp << 1;
}

/*=======================================================================
 |
 |		`h[@c^ovZ
 |
 |	void	dp_ai_roll()
 |
 =======================================================================*/
void	dp_ai_roll()
{
	/* qPOǑvZ */
	dp_ai.R100 = fltdata.IROLLA << 4;
}

/*=======================================================================
 |
 |		`hCʁ@c^ovZ
 |
 |	void	dp_ai_mhdg()
 |
 =======================================================================*/
void	dp_ai_mhdg()
{
	static	word	*chrtbl[5][2] = {
		{&dp_ai.A1740, &dp_ai.A1741},
		{&dp_ai.A1730, &dp_ai.A1731},
		{&dp_ai.A1720, &dp_ai.A1721},
		{&dp_ai.A1710, &dp_ai.A1711},
		{&dp_ai.A1700, &dp_ai.A1701}
	};
	ushort	delta_x;
	short	deg, i, j, n;
	ulong	tmp;

	/* owPOV̌vZ */
	tmp = (ulong)fltdata.IMAGHD << 16;
	delta_x = (ushort)((tmp % (20480L * 0x10000L / 180L)) >> 16);
	dp_ai.PX107 = (-(delta_x * 241 / 32 + 857)) << 1;

	/* XP[ڐ̐ݒ */
	deg = (short)(tmp / (20480L * 0x10000L / 180L)); /* x̌vZ */
	if (--deg < 0)			/* |POK\ */
		deg += 36;		/* ɂȂ̕␳ */
	for (i = 0; i < 5; i++) {
		if (deg >= 36)
			deg -= 36;	/* RUOKz̕␳ */
		/* ̃tHgAhXZbg */
		for (j = 0, n = deg; j < 2; j++) {
			*chrtbl[i][j] = numfont5_tbl[n % 10];
			n /= 10;
		}
		deg++;			/* {POK */
	}
}

/*=======================================================================
 |
 |		`h^Cx@c^ovZ
 |
 |	void	dp_ai_tas()
 |
 =======================================================================*/
void	dp_ai_tas()
{
	static	word	*chrtbl[5][3] = {
		{&dp_ai.A1600, &dp_ai.A1601, &dp_ai.A1602},
		{&dp_ai.A1610, &dp_ai.A1611, &dp_ai.A1612},
		{&dp_ai.A1620, &dp_ai.A1621, &dp_ai.A1622},
		{&dp_ai.A1630, &dp_ai.A1631, &dp_ai.A1632},
		{&dp_ai.A1640, &dp_ai.A1641, &dp_ai.A1642}
	};
	short	delta_y, n, knot, i, j;

	/* oxPOǓvZ */
	n = fltdata.IASPDT / 400;	/* SOOTO */
	delta_y = fltdata.IASPDT - (400 * n);	/* x̌vZ */
	if (n == 0) {
		/* TO */
		n++;
		delta_y -= 400;
	}
	dp_ai.PY106 = (-((short)(delta_y * 137L / 64L) + 785)) << 1;

	/* XP[ڐ̐ݒ */
	knot = (n - 1) * 50;		/* |TO̕\ */
	for (i = 0; i < 5; i++) {
		/* ̃tHgAhXZbg */
		for (j = 0, n = knot; j < 3; j++) {
			*chrtbl[i][j] = numfont5_tbl[n % 10];
			n /= 10;
		}
		knot += 50;		/* {TO */
	}
}

/*=======================================================================
 |
 |		`hCx@c^ovZ
 |
 |	void	dp_ai_alt()
 |
 =======================================================================*/
void	dp_ai_alt()
{
	static	word	*chrtbl[5][4] = {
		{&dp_ai.A1800, &dp_ai.A1801, &dp_ai.A1802, &dp_ai.A1803},
		{&dp_ai.A1810, &dp_ai.A1811, &dp_ai.A1812, &dp_ai.A1813},
		{&dp_ai.A1820, &dp_ai.A1821, &dp_ai.A1822, &dp_ai.A1823},
		{&dp_ai.A1830, &dp_ai.A1831, &dp_ai.A1832, &dp_ai.A1833},
		{&dp_ai.A1840, &dp_ai.A1841, &dp_ai.A1842, &dp_ai.A1843}
	};
	short	delta_y, n, feet, i, j;

	/* oxPOW̌vZ */
	if (fltdata.IHBALT >= 800) {		/* WOOPOOO */
		/* POOOȏ̎ */
		n = fltdata.IHBALT / 80;	/* WOPOO */
		delta_y = fltdata.IHBALT - (80 * n); /* x̌vZ */
		dp_ai.PY108 = (-(delta_y * 171 / 16 + 785)) << 1;
		feet = n * 10;
	} else {
		/* POOO̎ */
		n = fltdata.IHBALT / 8;		/* WPO */
		delta_y = fltdata.IHBALT - (8 * n); /* x̌vZ */
		if (n == 0) {
			/* PO */
			n++;
			delta_y -= 8;
		}
		dp_ai.PY108 = (-(delta_y * 107 + 785)) << 1;
		feet = n;
	}

	/* XP[ڐ̐ݒ */
	if (feet > 100)
		feet -= 10;		/* |POO\ */
	else
		feet -= 1;		/* |PO\ */
	for (i = 0; i < 5; i++) {
		/* ̃tHgAhXZbg */
		for (j = 0, n = feet; j < 4; j++) {
			*chrtbl[i][j] = numfont5_tbl[n % 10];
			n /= 10;
		}

		if (feet >= 100)
			feet += 10;	/* {POO */
		else
			feet += 1;	/* {PO */
	}
}

/*=======================================================================
 |
 |		`h[XP[@c^ovZ
 |
 |	void	dp_ai_rollscale()
 |
 =======================================================================*/
void	dp_ai_rollscale()
{
	dp_ai.R104B = 0;
	dp_ai.R104C = (word)(30L * 32768L / 180L) << 1;
	dp_ai.R104D = (word)(60L * 32768L / 180L) << 1;
	dp_ai.R104E = (word)(300L * 32768L / 180L) << 1;
	dp_ai.R104F = (word)(330L * 32768L / 180L) << 1;
}
